package cn.com.qmth.scancentral.controller.scan;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;

import cn.com.qmth.scancentral.controller.BaseController;
import cn.com.qmth.scancentral.service.ExamService;
import cn.com.qmth.scancentral.vo.scanexaminfo.ScanExamInfoVo;
import cn.com.qmth.scancentral.vo.scanexamlist.ScanExamListVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "扫描功能-考试接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/scan/exam")
@Aac(strict = false, auth = true)
public class ScanExamController extends BaseController {

    @Autowired
    private ExamService examService;

    @ApiOperation(value = "考试详情")
    @RequestMapping(value = "/info", method = RequestMethod.POST)
    public ScanExamInfoVo info(@RequestParam Long id) {
        return examService.getScanExamInfo(id,getAccessUser());
    }
    
    @ApiOperation(value = "考试列表")
    @RequestMapping(value = "/list", method = RequestMethod.POST)
    public List<ScanExamListVo> list() {
        return examService.getScanExamList();
    }

}
