package cn.com.qmth.scancentral.enums;

public enum SystemMode {

    MARKINGCLOUD("云阅卷"),

    STANDALONE("独立"),

    ;

    private String name;

    private static SystemMode current;

    SystemMode(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public static SystemMode getByName(String name) {
        for (SystemMode r : SystemMode.values()) {
            if (r.getName().equals(name)) {
                return r;
            }
        }
        return null;
    }

    public static SystemMode findByCode(String code) {
        for (SystemMode m : SystemMode.values()) {
            if (m.toString().equalsIgnoreCase(code)) {
                return m;
            }
        }
        return null;
    }

    public static void setCurrent(SystemMode mode) {
        current = mode;
    }

    public static SystemMode current() {
        return current;
    }

}
